> For clean Markdown of any page, append .md to the page URL. > For a complete documentation index, see https://docs.vellum.ai/developers/client-sdk/test-suites/runs/list-executions/llms.txt. > For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.vellum.ai/_mcp/server. # List Test Suite Executions GET https://api.vellum.ai/v1/test-suite-runs/{id}/executions Reference: https://docs.vellum.ai/developers/client-sdk/test-suites/runs/list-executions ## Authentication - `X-API-KEY` header (required) — API Key authentication via header ## Request ### Path parameters - `id` (string, required) — A UUID string identifying this test suite run. ### Query parameters - `expand` (list of string, optional) — The response fields to expand for more information. - 'metric_results.metric_label' expands the metric label for each metric result. - 'metric_results.metric_definition' expands the metric definition for each metric result. - 'metric_results.metric_definition.name' expands the metric definition name for each metric result. - `limit` (integer, optional) — Number of results to return per page. - `offset` (integer, optional) — The initial index from which to return the results. ## Response ### 200 - `count` (integer, required) - `next` (string, required, nullable) - `previous` (string, required, nullable) - `results` (list of TestSuiteRunExecution, required) ## Types ### TestSuiteRunExecution - `id` (string, required) - `test_case_id` (string, required) - `outputs` (list of TestSuiteRunExecutionOutput, required) - `metric_results` (list of TestSuiteRunExecutionMetricResult, required) ### TestSuiteRunExecutionOutput ### TestSuiteRunExecutionMetricResult - `metric_id` (string, required) - `outputs` (list of TestSuiteRunMetricOutput, required) - `metric_label` (string, optional) - `metric_definition` (TestSuiteRunExecutionMetricDefinition, optional) ### TestSuiteRunExecutionStringOutput Execution output of an entity evaluated during a Test Suite Run that is of type STRING - `name` (string, required) - `type` (enum, required) - Allowed values: `STRING` - `value` (string, required, nullable) - `output_variable_id` (string, required) ### TestSuiteRunExecutionNumberOutput Execution output of an entity evaluated during a Test Suite Run that is of type NUMBER - `name` (string, required) - `type` (enum, required) - Allowed values: `NUMBER` - `value` (double, required, nullable) - `output_variable_id` (string, required) ### TestSuiteRunExecutionJsonOutput Execution output of an entity evaluated during a Test Suite Run that is of type JSON - `name` (string, required) - `type` (enum, required) - Allowed values: `JSON` - `value` (any, required, nullable) - `output_variable_id` (string, required) ### TestSuiteRunExecutionChatHistoryOutput Execution output of an entity evaluated during a Test Suite Run that is of type CHAT_HISTORY - `name` (string, required) - `type` (enum, required) - Allowed values: `CHAT_HISTORY` - `value` (list of ChatMessage, required, nullable) - `output_variable_id` (string, required) ### TestSuiteRunExecutionSearchResultsOutput Execution output of an entity evaluated during a Test Suite Run that is of type SEARCH_RESULTS - `name` (string, required) - `type` (enum, required) - Allowed values: `SEARCH_RESULTS` - `value` (list of SearchResult, required, nullable) - `output_variable_id` (string, required) ### TestSuiteRunExecutionErrorOutput Execution output of an entity evaluated during a Test Suite Run that is of type ERROR - `name` (string, required) - `type` (enum, required) - Allowed values: `ERROR` - `value` (VellumError, required, nullable) - `output_variable_id` (string, required) ### TestSuiteRunExecutionFunctionCallOutput Execution output of an entity evaluated during a Test Suite Run that is of type FUNCTION_CALL - `name` (string, required) - `type` (enum, required) - Allowed values: `FUNCTION_CALL` - `value` (FunctionCall, required, nullable) — The final resolved function call value. - `output_variable_id` (string, required) ### TestSuiteRunExecutionArrayOutput Execution output of an entity evaluated during a Test Suite Run that is of type ARRAY - `name` (string, required) - `type` (enum, required) - Allowed values: `ARRAY` - `value` (list of VellumValue, required, nullable) - `output_variable_id` (string, required) ### TestSuiteRunMetricOutput ### TestSuiteRunExecutionMetricDefinition - `id` (string, optional) - `label` (string, optional) - `name` (string, optional) ### ChatMessage - `role` (enum, required) — * `SYSTEM` - System * `ASSISTANT` - Assistant * `USER` - User * `FUNCTION` - Function - Allowed values: `SYSTEM`, `ASSISTANT`, `USER`, `FUNCTION` - `text` (string, optional, nullable) - `content` (ChatMessageContent, optional, nullable) - `source` (string, optional, nullable) — An optional identifier representing who or what generated this message. - `metadata` (map from string to any, optional, nullable) ### SearchResult - `text` (string, required) — The text of the chunk that matched the search query. - `score` (double, required) — A score representing how well the chunk matches the search query. - `keywords` (list of string, required) - `document` (SearchResultDocument, required) — The document that contains the chunk that matched the search query. - `meta` (SearchResultMeta, optional, nullable) — Additional information about the search result. ### VellumError - `code` (enum, required) — * `INVALID_REQUEST` - INVALID_REQUEST * `INVALID_INPUTS` - INVALID_INPUTS * `PROVIDER_ERROR` - PROVIDER_ERROR * `PROVIDER_CREDENTIALS_UNAVAILABLE` - PROVIDER_CREDENTIALS_UNAVAILABLE * `INTEGRATION_CREDENTIALS_UNAVAILABLE` - INTEGRATION_CREDENTIALS_UNAVAILABLE * `REQUEST_TIMEOUT` - REQUEST_TIMEOUT * `INTERNAL_SERVER_ERROR` - INTERNAL_SERVER_ERROR * `USER_DEFINED_ERROR` - USER_DEFINED_ERROR * `WORKFLOW_CANCELLED` - WORKFLOW_CANCELLED * `NODE_CANCELLED` - NODE_CANCELLED * `PROVIDER_QUOTA_EXCEEDED` - PROVIDER_QUOTA_EXCEEDED * `CHAT_QUOTA_EXCEEDED` - CHAT_QUOTA_EXCEEDED - Allowed values: `INVALID_REQUEST`, `INVALID_INPUTS`, `PROVIDER_ERROR`, `PROVIDER_CREDENTIALS_UNAVAILABLE`, `INTEGRATION_CREDENTIALS_UNAVAILABLE`, `REQUEST_TIMEOUT`, `INTERNAL_SERVER_ERROR`, `USER_DEFINED_ERROR`, `WORKFLOW_CANCELLED`, `NODE_CANCELLED`, `PROVIDER_QUOTA_EXCEEDED`, `CHAT_QUOTA_EXCEEDED` - `message` (string, required) - `raw_data` (map from string to any, optional, nullable) ### FunctionCall The final resolved function call value. - `arguments` (map from string to any, required) - `name` (string, required) - `id` (string, optional, nullable) ### VellumValue ### TestSuiteRunMetricStringOutput Output for a test suite run metric that is of type STRING - `value` (string, required, nullable) - `name` (string, required) - `type` (enum, optional) — * `STRING` - STRING - Allowed values: `STRING` ### TestSuiteRunMetricNumberOutput Output for a test suite run metric that is of type NUMBER - `value` (double, required, nullable) - `name` (string, required) - `type` (enum, optional) — * `NUMBER` - NUMBER - Allowed values: `NUMBER` ### TestSuiteRunMetricJSONOutput Output for a test suite run metric that is of type NUMBER - `value` (any, required, nullable) - `name` (string, required) - `type` (enum, optional) — * `JSON` - JSON - Allowed values: `JSON` ### TestSuiteRunMetricErrorOutput Output for a test suite run metric that is of type ERROR - `value` (VellumError, required) - `name` (string, required) - `type` (enum, optional) — * `ERROR` - ERROR - Allowed values: `ERROR` ### TestSuiteRunMetricArrayOutput Output for a test suite run metric that is of type ARRAY - `value` (list of VellumValue, required, nullable) - `name` (string, required) - `type` (enum, optional) — * `ARRAY` - ARRAY - Allowed values: `ARRAY` ### ChatMessageContent ### SearchResultDocument - `label` (string, required) — The human-readable name for the document. - `id` (string, optional, nullable) — The ID of the document. - `external_id` (string, optional, nullable) — The unique ID of the document as represented in an external system and specified when it was originally uploaded. - `metadata` (map from string to any, optional, nullable) — A previously supplied JSON object containing metadata that can be filtered on when searching. ### SearchResultMeta - `source` (SearchResultMetaSource, optional, nullable) ### StringVellumValue A value representing a string. - `type` (enum, required) - Allowed values: `STRING` - `value` (string, required, nullable) ### NumberVellumValue A value representing a number. - `type` (enum, required) - Allowed values: `NUMBER` - `value` (double, required, nullable) ### JsonVellumValue A value representing a JSON object. - `type` (enum, required) - Allowed values: `JSON` - `value` (any, required, nullable) ### AudioVellumValue A base Vellum primitive value representing audio. - `type` (enum, required) - Allowed values: `AUDIO` - `value` (VellumAudio, required, nullable) ### VideoVellumValue A base Vellum primitive value representing a video. - `type` (enum, required) - Allowed values: `VIDEO` - `value` (VellumVideo, required, nullable) ### ImageVellumValue A base Vellum primitive value representing an image. - `type` (enum, required) - Allowed values: `IMAGE` - `value` (VellumImage, required, nullable) ### DocumentVellumValue A base Vellum primitive value representing a document. - `type` (enum, required) - Allowed values: `DOCUMENT` - `value` (VellumDocument, required, nullable) ### FunctionCallVellumValue A value representing a Function Call. - `type` (enum, required) - Allowed values: `FUNCTION_CALL` - `value` (FunctionCall, required, nullable) — The final resolved function call value. ### ErrorVellumValue A value representing an Error. - `type` (enum, required) - Allowed values: `ERROR` - `value` (VellumError, required, nullable) ### ArrayVellumValue A value representing an array of Vellum variable values. - `type` (enum, required) - Allowed values: `ARRAY` - `value` (list of VellumValue, required, nullable) ### ChatHistoryVellumValue A value representing Chat History. - `type` (enum, required) - Allowed values: `CHAT_HISTORY` - `value` (list of ChatMessage, required, nullable) ### SearchResultsVellumValue A value representing Search Results. - `type` (enum, required) - Allowed values: `SEARCH_RESULTS` - `value` (list of SearchResult, required, nullable) ### ThinkingVellumValue A value representing Thinking mode output. - `type` (enum, required) - Allowed values: `THINKING` - `value` (StringVellumValue, required, nullable) — A value representing a string. ### StringChatMessageContent A string value that is used in a chat message. - `type` (enum, required) - Allowed values: `STRING` - `value` (string, required) ### FunctionCallChatMessageContent A function call value that is used in a chat message. - `type` (enum, required) - Allowed values: `FUNCTION_CALL` - `value` (FunctionCallChatMessageContentValue, required) — The final resolved function call value. ### ArrayChatMessageContent A list of chat message content items. - `type` (enum, required) - Allowed values: `ARRAY` - `value` (list of ArrayChatMessageContentItem, required) ### AudioChatMessageContent An audio value that is used in a chat message. - `type` (enum, required) - Allowed values: `AUDIO` - `value` (VellumAudio, required) ### VideoChatMessageContent A video value that is used in a chat message. - `type` (enum, required) - Allowed values: `VIDEO` - `value` (VellumVideo, required) ### ImageChatMessageContent An image value that is used in a chat message. - `type` (enum, required) - Allowed values: `IMAGE` - `value` (VellumImage, required) ### DocumentChatMessageContent A document value that is used in a chat message. - `type` (enum, required) - Allowed values: `DOCUMENT` - `value` (VellumDocument, required) ### SearchResultMetaSource ### VellumAudio - `src` (string, required) — The reference to the source data. This can be one of the following formats: 1. A base64-encoded data URL (e.g., 'data:application/pdf;base64,JVBERi0xLjQKJcfs...'). 2. A url pointing to a file accessible over HTTP or HTTPS. 3. A reference to a file that's been previously uploaded to Vellum, in the form of 'vellum:uploaded-file:\{uploaded\_file\_id}'. You can use the Uploaded Files API to retrieve the url of the uploaded file given its ID. See [https://docs.vellum.ai/developers/client-sdk/uploaded-files/retrieve](https://docs.vellum.ai/developers/client-sdk/uploaded-files/retrieve) for details. - `metadata` (map from string to any, optional, nullable) ### VellumVideo - `src` (string, required) — The reference to the source data. This can be one of the following formats: 1. A base64-encoded data URL (e.g., 'data:application/pdf;base64,JVBERi0xLjQKJcfs...'). 2. A url pointing to a file accessible over HTTP or HTTPS. 3. A reference to a file that's been previously uploaded to Vellum, in the form of 'vellum:uploaded-file:\{uploaded\_file\_id}'. You can use the Uploaded Files API to retrieve the url of the uploaded file given its ID. See [https://docs.vellum.ai/developers/client-sdk/uploaded-files/retrieve](https://docs.vellum.ai/developers/client-sdk/uploaded-files/retrieve) for details. - `metadata` (map from string to any, optional, nullable) ### VellumImage - `src` (string, required) — The reference to the source data. This can be one of the following formats: 1. A base64-encoded data URL (e.g., 'data:application/pdf;base64,JVBERi0xLjQKJcfs...'). 2. A url pointing to a file accessible over HTTP or HTTPS. 3. A reference to a file that's been previously uploaded to Vellum, in the form of 'vellum:uploaded-file:\{uploaded\_file\_id}'. You can use the Uploaded Files API to retrieve the url of the uploaded file given its ID. See [https://docs.vellum.ai/developers/client-sdk/uploaded-files/retrieve](https://docs.vellum.ai/developers/client-sdk/uploaded-files/retrieve) for details. - `metadata` (map from string to any, optional, nullable) ### VellumDocument - `src` (string, required) — The reference to the source data. This can be one of the following formats: 1. A base64-encoded data URL (e.g., 'data:application/pdf;base64,JVBERi0xLjQKJcfs...'). 2. A url pointing to a file accessible over HTTP or HTTPS. 3. A reference to a file that's been previously uploaded to Vellum, in the form of 'vellum:uploaded-file:\{uploaded\_file\_id}'. You can use the Uploaded Files API to retrieve the url of the uploaded file given its ID. See [https://docs.vellum.ai/developers/client-sdk/uploaded-files/retrieve](https://docs.vellum.ai/developers/client-sdk/uploaded-files/retrieve) for details. - `metadata` (map from string to any, optional, nullable) ### FunctionCallChatMessageContentValue The final resolved function call value. - `name` (string, required) - `arguments` (map from string to any, required) - `id` (string, optional, nullable) ### ArrayChatMessageContentItem ### PdfSearchResultMetaSource The source of a search result from a PDF document. - `document_type` (enum, required) - Allowed values: `PDF` - `start_page_num` (integer, required, nullable) — The 1-indexed page number where the chunk starts in the document. Only available for supported chunking strategies and document types. - `end_page_num` (integer, required, nullable) — The 1-indexed page number where the chunk ends in the document. Only available for supported chunking strategies and document types. ## Examples **Response** ```json { "count": 123, "next": "http://api.example.org/accounts/?offset=400&limit=100", "previous": "http://api.example.org/accounts/?offset=200&limit=100", "results": [ { "id": "string", "test_case_id": "string", "outputs": [ { "name": "string", "type": "STRING", "value": "string", "output_variable_id": "string" } ], "metric_results": [ { "metric_id": "string", "outputs": [ { "value": "string", "type": "STRING", "name": "string" } ], "metric_label": "string", "metric_definition": { "id": "string", "label": "string", "name": "string" } } ] } ] } ``` **SDK Code** ```python import requests url = "https://api.vellum.ai/v1/test-suite-runs/id/executions" headers = {"X-API-KEY": ""} response = requests.get(url, headers=headers) print(response.json()) ``` ```typescript import { VellumClient } from "vellum-ai"; const client = new VellumClient({ apiKey: "YOUR_API_KEY", apiVersion: "YOUR_API_VERSION" }); await client.testSuiteRuns.listExecutions("id"); ``` ```go package main import ( "fmt" "net/http" "io" ) func main() { url := "https://api.vellum.ai/v1/test-suite-runs/id/executions" req, _ := http.NewRequest("GET", url, nil) req.Header.Add("X-API-KEY", "") res, _ := http.DefaultClient.Do(req) defer res.Body.Close() body, _ := io.ReadAll(res.Body) fmt.Println(res) fmt.Println(string(body)) } ``` ```ruby require 'uri' require 'net/http' url = URI("https://api.vellum.ai/v1/test-suite-runs/id/executions") http = Net::HTTP.new(url.host, url.port) http.use_ssl = true request = Net::HTTP::Get.new(url) request["X-API-KEY"] = '' response = http.request(request) puts response.read_body ``` ```java import com.mashape.unirest.http.HttpResponse; import com.mashape.unirest.http.Unirest; HttpResponse response = Unirest.get("https://api.vellum.ai/v1/test-suite-runs/id/executions") .header("X-API-KEY", "") .asString(); ``` ```php request('GET', 'https://api.vellum.ai/v1/test-suite-runs/id/executions', [ 'headers' => [ 'X-API-KEY' => '', ], ]); echo $response->getBody(); ``` ```csharp using RestSharp; var client = new RestClient("https://api.vellum.ai/v1/test-suite-runs/id/executions"); var request = new RestRequest(Method.GET); request.AddHeader("X-API-KEY", ""); IRestResponse response = client.Execute(request); ``` ```swift import Foundation let headers = ["X-API-KEY": ""] let request = NSMutableURLRequest(url: NSURL(string: "https://api.vellum.ai/v1/test-suite-runs/id/executions")! as URL, cachePolicy: .useProtocolCachePolicy, timeoutInterval: 10.0) request.httpMethod = "GET" request.allHTTPHeaderFields = headers let session = URLSession.shared let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in if (error != nil) { print(error as Any) } else { let httpResponse = response as? HTTPURLResponse print(httpResponse) } }) dataTask.resume() ```